#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXBUFF		0x8000

#define	MAXPAT		0x180


int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		buff[MAXBUFF];

	int		patpos[MAXPAT],patlen[MAXPAT];
	int		patdat[128];
	int		c_patdat[64];
	int		patcnt;

	int		width,height;
	int		wb;
	int		x,y;
	int		m,n,i,j,k;
	int		col,colct;
	int		a0,a1,a2,a3,c;
	int		a00,a01,a02,a03,a04,a05,a06,a07;
	int		a08,a09,a10,a11,a12,a13,a14,a15;
	int		sft;
	int		filelen;

	if (argc != 3) {
		fprintf(stderr, "Usage: convchara infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	i = 0;
	while ( (c = fgetc(infp)) != EOF) {
		buff[i] = c;
		i ++;
	}
	filelen = i;

	fseek(infp,0,SEEK_SET);

	a0 = fgetc(infp);
	a1 = fgetc(infp);
	for (i = 0;;i ++) {
		a2 = fgetc(infp);
		a3 = fgetc(infp);
		patpos[i] = (a0 + a1*0x100);
		patlen[i] = (a2 + a3*0x100) - (a0 + a1*0x100);
		if (a2 == 0x00 && a3 == 0x00) {
			patlen[i] = 0x11;
			break;
		}
		a0 = a2;
		a1 = a3;
	}

	patcnt = i;

	for (i = 0;i <= patcnt;i ++) {

		fseek(infp,0x300+patpos[i],SEEK_SET);

		c = fgetc(infp);
		if (c == 0x00) {
			if (patlen[i] != 0x31) {
				printf("length illigal\n");
				printf("%d %02x %02x %02x\n",i,patpos[i],patlen[i],c);
				exit(1);
			}
		} else {
			if (patlen[i] != 0x11) {
				printf("length illigal\n");
				printf("%d %02x %02x %02x\n",i,patpos[i],patlen[i],c);
				exit(1);
			}
		}

		for (j = 0;j < 128;j ++) {
			patdat[j] = 0x08;
		}

		if (c == 0x00) {
			col = 0x01;
			colct = 3;
		} else {
			col = c;
			colct = 1;
		}

		for (j = 0;j < colct;j ++ ) {
			for (y = 0;y < 8;y ++) {

				c = fgetc(infp);
				sft = 0x80;
				for (x = 0;x < 8;x ++) {
					if ((sft & c) != 0) {
						patdat[y*16+x+0] |= col;
					}
					sft /= 2;
				}

				c = fgetc(infp);
				sft = 0x80;
				for (x = 0;x < 8;x ++) {
					if ((sft & c) != 0) {
						patdat[y*16+x+8] |= col;
					}
					sft /= 2;
				}

			}
			col *= 2;
		}

/* hbgԈ */
		for (y = 0;y < 8;y ++) {

			a00 = patdat[y*16+ 0];
			a01 = patdat[y*16+ 1];
			a02 = patdat[y*16+ 2];
			a03 = patdat[y*16+ 3];
			a04 = patdat[y*16+ 4];
			a05 = patdat[y*16+ 5];
			a06 = patdat[y*16+ 6];
			a07 = patdat[y*16+ 7];
			a08 = patdat[y*16+ 8];
			a09 = patdat[y*16+ 9];
			a10 = patdat[y*16+10];
			a11 = patdat[y*16+11];
			a12 = patdat[y*16+12];
			a13 = patdat[y*16+13];
			a14 = patdat[y*16+14];
			a15 = patdat[y*16+15];

			c_patdat[y*8+0] = a00;
			c_patdat[y*8+1] = a02;
			c_patdat[y*8+2] = a04;
			c_patdat[y*8+3] = a06;
			c_patdat[y*8+4] = a08;
			c_patdat[y*8+5] = a10;
			c_patdat[y*8+6] = a12;
			c_patdat[y*8+7] = a14;


			if (a00 == a02 && a01 == a03) {
				if ( (y%2) == 0) {
					c_patdat[y*8+0] = a00;
					c_patdat[y*8+1] = a01;
				} else {
					c_patdat[y*8+0] = a01;
					c_patdat[y*8+1] = a00;
				}
			}

			if (a02 == a04 && a03 == a05) {
				if ( (y%2) == 0) {
					c_patdat[y*8+2] = a02;
					c_patdat[y*8+1] = a03;
				} else {
					c_patdat[y*8+2] = a03;
					c_patdat[y*8+1] = a02;
				}
			}

			if (a04 == a06 && a05 == a07) {
				if ( (y%2) == 0) {
					c_patdat[y*8+2] = a04;
					c_patdat[y*8+3] = a05;
				} else {
					c_patdat[y*8+2] = a05;
					c_patdat[y*8+3] = a04;
				}
			}

			if (a06 == a08 && a07 == a09) {
				if ( (y%2) == 0) {
					c_patdat[y*8+4] = a06;
					c_patdat[y*8+3] = a07;
				} else {
					c_patdat[y*8+4] = a07;
					c_patdat[y*8+3] = a06;
				}
			}

			if (a08 == a10 && a09 == a11) {
				if ( (y%2) == 0) {
					c_patdat[y*8+4] = a08;
					c_patdat[y*8+5] = a09;
				} else {
					c_patdat[y*8+4] = a09;
					c_patdat[y*8+5] = a08;
				}
			}

			if (a10 == a12 && a11 == a13) {
				if ( (y%2) == 0) {
					c_patdat[y*8+6] = a10;
					c_patdat[y*8+5] = a11;
				} else {
					c_patdat[y*8+6] = a11;
					c_patdat[y*8+5] = a10;
				}
			}

			if (a12 == a14 && a13 == a15) {
				if ( (y%2) == 0) {
					c_patdat[y*8+6] = a12;
					c_patdat[y*8+7] = a13;
				} else {
					c_patdat[y*8+6] = a13;
					c_patdat[y*8+7] = a12;
				}
			}


		}

/* t@Cɔf */

		if (patlen[i] == 0x31) {

			for (y = 0;y < 8;y ++) {
				buff[ 0x301+patpos[i]+y*6+0] = c_patdat[y*8+0];
				buff[ 0x301+patpos[i]+y*6+1] = c_patdat[y*8+1];
				buff[ 0x301+patpos[i]+y*6+2] = c_patdat[y*8+2] | (c_patdat[y*8+3] << 4);
				buff[ 0x301+patpos[i]+y*6+3] = c_patdat[y*8+4];
				buff[ 0x301+patpos[i]+y*6+4] = c_patdat[y*8+5];
				buff[ 0x301+patpos[i]+y*6+5] = c_patdat[y*8+6] | (c_patdat[y*8+7] << 4);
			}

		} else {

			for (y = 0;y < 8;y ++) {
				buff[ 0x301+patpos[i]+y] =
						( (c_patdat[y*8+0] != 0x08) ? 0x80 : 0x00) + 
						( (c_patdat[y*8+1] != 0x08) ? 0x40 : 0x00) + 
						( (c_patdat[y*8+2] != 0x08) ? 0x20 : 0x00) + 
						( (c_patdat[y*8+3] != 0x08) ? 0x10 : 0x00) + 
						( (c_patdat[y*8+4] != 0x08) ? 0x08 : 0x00) + 
						( (c_patdat[y*8+5] != 0x08) ? 0x04 : 0x00) + 
						( (c_patdat[y*8+6] != 0x08) ? 0x02 : 0x00) + 
						( (c_patdat[y*8+7] != 0x08) ? 0x01 : 0x00);
			}
			for (x = 0;x < 8;x ++) {
				buff[ 0x301+patpos[i]+x+8] = 0x00;
			}

		}


	}

	for (i = 0;i < filelen;i ++) {
		fputc(buff[i],outfp);
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}

